'use strict';

var e = require('react');
var emotion = require('emotion');
var i = require('@contentful/f36-tokens');
var f36Badge = require('@contentful/f36-badge');
var f36Core = require('@contentful/f36-core');
var f36Icons = require('@contentful/f36-icons');
var f36Icon = require('@contentful/f36-icon');
var f36Typography = require('@contentful/f36-typography');
var f36DragHandle = require('@contentful/f36-drag-handle');
var f36Button = require('@contentful/f36-button');
var f36Menu = require('@contentful/f36-menu');
var f36Skeleton = require('@contentful/f36-skeleton');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var e__default = /*#__PURE__*/_interopDefault(e);
var i__default = /*#__PURE__*/_interopDefault(i);

var K=Object.defineProperty,Q=Object.defineProperties;var V=Object.getOwnPropertyDescriptors;var p=Object.getOwnPropertySymbols;var k=Object.prototype.hasOwnProperty,N=Object.prototype.propertyIsEnumerable;var S=(t,n,o)=>n in t?K(t,n,{enumerable:!0,configurable:!0,writable:!0,value:o}):t[n]=o,l=(t,n)=>{for(var o in n||(n={}))k.call(n,o)&&S(t,o,n[o]);if(p)for(var o of p(n))N.call(n,o)&&S(t,o,n[o]);return t},d=(t,n)=>Q(t,V(n));var w=(t,n)=>{var o={};for(var r in t)k.call(t,r)&&n.indexOf(r)<0&&(o[r]=t[r]);if(t!=null&&p)for(var r of p(t))n.indexOf(r)<0&&N.call(t,r)&&(o[r]=t[r]);return o};var M=()=>({root:emotion.css({display:"block",listStyle:"none",margin:0,padding:0,border:`1px solid ${i__default.default.gray200}`,borderBottom:"none",borderRadius:i__default.default.borderRadiusMedium,overflow:"hidden"})});function A(t,n){let o=M();return e__default.default.createElement("ul",{"data-test-id":t.testId||"cf-ui-entity-list",ref:n,className:emotion.cx(o.root,t.className),style:t.style},t.children)}A.displayName="EntityList";var B=e__default.default.forwardRef(A);var $=()=>({root:t=>emotion.css(d(l({display:"flex",boxShadow:`inset 0 -1px 0 ${i__default.default.gray200}`,position:"relative",transition:`${i__default.default.transitionDurationShort} ${i__default.default.transitionEasingDefault}`,transitionProperty:"box-shadow, background-color",backgroundColor:i__default.default.colorWhite},t.isDragActive?{boxShadow:i__default.default.boxShadowHeavy}:{}),{"&:hover":{backgroundColor:i__default.default.gray100}})),card:t=>emotion.css({display:"flex",textDecoration:"none",minWidth:0,width:"100%",minHeight:i__default.default.spacing3Xl,padding:i__default.default.spacingXs,margin:0,border:"none",background:"none",textAlign:"left",cursor:t?"pointer":"inherit","&:focus-visible":{boxShadow:`inset ${i__default.default.glowPrimary}`,outline:"none"}}),content:emotion.css({flexGrow:1,minWidth:0,position:"relative"}),media:emotion.css({display:"flex",flexShrink:0,alignItems:"center",justifyContent:"center",backgroundColor:i__default.default.gray200,width:i__default.default.spacing2Xl,height:i__default.default.spacing2Xl,margin:"0",marginRight:i__default.default.spacingXs}),thumbnail:emotion.css({display:"block",width:"100%",height:"100%",objectFit:"cover"}),contentType:emotion.css({marginLeft:i__default.default.spacingXs}),entityType:emotion.css({textTransform:"capitalize"}),description:emotion.css({"&::before":{content:'"|"',color:i__default.default.gray400,height:"25%",marginTop:i__default.default.spacing2Xs,marginLeft:i__default.default.spacing2Xs,marginRight:i__default.default.spacing2Xs}}),meta:emotion.css({marginLeft:"auto",flexShrink:0}),dragHandle:emotion.css({borderBottomLeftRadius:"0",borderTopLeftRadius:"0",boxShadow:`inset 0 -1px 0 ${i__default.default.gray200}`}),menuTrigger:emotion.css({padding:"0 0.125rem",minHeight:"1.5rem",height:"1rem",margin:`${i__default.default.spacingXs} ${i__default.default.spacingXs} 0 0`})});var pt={asset:f36Icons.AssetIcon,entry:f36Icons.EntryIcon,release:f36Icons.ReleaseIcon,page:f36Icons.PageIcon,experience:f36Icons.PaintBrushIcon},y=dt=>{var C=dt,{className:t,testId:n="cf-ui-entity-list-item",title:o,description:r,contentType:b,entityType:m="entry",withThumbnail:W=!0,thumbnailUrl:I,thumbnailAltText:O,status:f,actions:h,withDragHandle:z,isDragActive:P,isLoading:U,onClick:H,href:g,cardDragHandleProps:_,cardDragHandleComponent:T,isActionsDisabled:j=!1}=C,G=w(C,["className","testId","title","description","contentType","entityType","withThumbnail","thumbnailUrl","thumbnailAltText","status","actions","withDragHandle","isDragActive","isLoading","onClick","href","cardDragHandleProps","cardDragHandleComponent","isActionsDisabled"]);let s=$(),q=()=>{if(T)return T;if(z)return e__default.default.createElement(f36DragHandle.DragHandle,l({className:s.dragHandle,isActive:P,label:"Reorder entry"},_))},u="article",v=!1;(g||H)&&(u=g?"a":"button",v=!0);let J=f==="archived"||!I;return e__default.default.createElement("li",d(l({},G),{className:emotion.cx(s.root({isDragActive:P}),t),"data-test-id":n}),q(),U?e__default.default.createElement("article",{className:s.card(!1)},e__default.default.createElement(f36Skeleton.Skeleton.Container,{svgHeight:46,clipId:"f36-entity-list-item-skeleton"},e__default.default.createElement(f36Skeleton.Skeleton.Image,{height:46,width:46}),e__default.default.createElement(f36Skeleton.Skeleton.BodyText,{numberOfLines:2,lineHeight:18,offsetLeft:54}))):e__default.default.createElement(e__default.default.Fragment,null,e__default.default.createElement(u,l(l({className:s.card(v),onClick:H,href:g},g?{target:"_blank"}:{}),u==="button"?{type:"button"}:{}),W&&e__default.default.createElement("figure",{className:s.media},J?e__default.default.createElement(f36Icon.Icon,{as:pt[m.toLowerCase()],variant:"muted","data-test-id":`thumbnail-icon-${m.toLowerCase()}`}):e__default.default.createElement("img",{src:I,className:s.thumbnail,alt:O})),e__default.default.createElement("div",{className:s.content},e__default.default.createElement(f36Core.Flex,null,e__default.default.createElement(f36Typography.Text,{as:"h3",lineHeight:"lineHeightM",fontColor:"gray900",fontWeight:"fontWeightDemiBold",isTruncated:!0},o),b&&e__default.default.createElement(f36Typography.Text,{as:"span",lineHeight:"lineHeightM",fontColor:"gray600",className:s.contentType,isTruncated:!0},"(",b,")")),e__default.default.createElement(f36Core.Flex,{marginTop:"spacing2Xs"},m&&e__default.default.createElement(f36Typography.Text,{lineHeight:"lineHeightM",fontColor:"gray600",className:s.entityType},m),r&&e__default.default.createElement(f36Typography.Text,{as:"p",lineHeight:"lineHeightM",fontColor:"gray900",isTruncated:!0,className:s.description},r))),e__default.default.createElement(f36Core.Flex,{className:s.meta,alignItems:"flex-start",paddingLeft:"spacingXs"},f&&e__default.default.createElement(f36Core.Box,{marginRight:h?"spacingXs":"none"},e__default.default.createElement(f36Badge.EntityStatusBadge,{entityStatus:f})))),h&&e__default.default.createElement(f36Menu.Menu,null,e__default.default.createElement(f36Menu.Menu.Trigger,null,e__default.default.createElement(f36Button.Button,{isDisabled:j,startIcon:e__default.default.createElement(f36Icons.MoreHorizontalIcon,null),variant:"transparent","aria-label":"Actions",size:"small",className:s.menuTrigger})),e__default.default.createElement(f36Menu.Menu.List,null,h))))};y.displayName="EntityListItem";var F=B;F.Item=y;

exports.EntityList = F;
exports.EntityListItem = y;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.js.map