import e from 'react';
import { cx, css } from 'emotion';
import i from '@contentful/f36-tokens';
import { EntityStatusBadge } from '@contentful/f36-badge';
import { Flex, Box } from '@contentful/f36-core';
import { MoreHorizontalIcon, AssetIcon, EntryIcon, ReleaseIcon, PageIcon, PaintBrushIcon } from '@contentful/f36-icons';
import { Icon } from '@contentful/f36-icon';
import { Text } from '@contentful/f36-typography';
import { DragHandle } from '@contentful/f36-drag-handle';
import { Button } from '@contentful/f36-button';
import { Menu } from '@contentful/f36-menu';
import { Skeleton } from '@contentful/f36-skeleton';

var K=Object.defineProperty,Q=Object.defineProperties;var V=Object.getOwnPropertyDescriptors;var p=Object.getOwnPropertySymbols;var k=Object.prototype.hasOwnProperty,N=Object.prototype.propertyIsEnumerable;var S=(t,n,o)=>n in t?K(t,n,{enumerable:!0,configurable:!0,writable:!0,value:o}):t[n]=o,l=(t,n)=>{for(var o in n||(n={}))k.call(n,o)&&S(t,o,n[o]);if(p)for(var o of p(n))N.call(n,o)&&S(t,o,n[o]);return t},d=(t,n)=>Q(t,V(n));var w=(t,n)=>{var o={};for(var r in t)k.call(t,r)&&n.indexOf(r)<0&&(o[r]=t[r]);if(t!=null&&p)for(var r of p(t))n.indexOf(r)<0&&N.call(t,r)&&(o[r]=t[r]);return o};var M=()=>({root:css({display:"block",listStyle:"none",margin:0,padding:0,border:`1px solid ${i.gray200}`,borderBottom:"none",borderRadius:i.borderRadiusMedium,overflow:"hidden"})});function A(t,n){let o=M();return e.createElement("ul",{"data-test-id":t.testId||"cf-ui-entity-list",ref:n,className:cx(o.root,t.className),style:t.style},t.children)}A.displayName="EntityList";var B=e.forwardRef(A);var $=()=>({root:t=>css(d(l({display:"flex",boxShadow:`inset 0 -1px 0 ${i.gray200}`,position:"relative",transition:`${i.transitionDurationShort} ${i.transitionEasingDefault}`,transitionProperty:"box-shadow, background-color",backgroundColor:i.colorWhite},t.isDragActive?{boxShadow:i.boxShadowHeavy}:{}),{"&:hover":{backgroundColor:i.gray100}})),card:t=>css({display:"flex",textDecoration:"none",minWidth:0,width:"100%",minHeight:i.spacing3Xl,padding:i.spacingXs,margin:0,border:"none",background:"none",textAlign:"left",cursor:t?"pointer":"inherit","&:focus-visible":{boxShadow:`inset ${i.glowPrimary}`,outline:"none"}}),content:css({flexGrow:1,minWidth:0,position:"relative"}),media:css({display:"flex",flexShrink:0,alignItems:"center",justifyContent:"center",backgroundColor:i.gray200,width:i.spacing2Xl,height:i.spacing2Xl,margin:"0",marginRight:i.spacingXs}),thumbnail:css({display:"block",width:"100%",height:"100%",objectFit:"cover"}),contentType:css({marginLeft:i.spacingXs}),entityType:css({textTransform:"capitalize"}),description:css({"&::before":{content:'"|"',color:i.gray400,height:"25%",marginTop:i.spacing2Xs,marginLeft:i.spacing2Xs,marginRight:i.spacing2Xs}}),meta:css({marginLeft:"auto",flexShrink:0}),dragHandle:css({borderBottomLeftRadius:"0",borderTopLeftRadius:"0",boxShadow:`inset 0 -1px 0 ${i.gray200}`}),menuTrigger:css({padding:"0 0.125rem",minHeight:"1.5rem",height:"1rem",margin:`${i.spacingXs} ${i.spacingXs} 0 0`})});var pt={asset:AssetIcon,entry:EntryIcon,release:ReleaseIcon,page:PageIcon,experience:PaintBrushIcon},y=dt=>{var C=dt,{className:t,testId:n="cf-ui-entity-list-item",title:o,description:r,contentType:b,entityType:m="entry",withThumbnail:W=!0,thumbnailUrl:I,thumbnailAltText:O,status:f,actions:h,withDragHandle:z,isDragActive:P,isLoading:U,onClick:H,href:g,cardDragHandleProps:_,cardDragHandleComponent:T,isActionsDisabled:j=!1}=C,G=w(C,["className","testId","title","description","contentType","entityType","withThumbnail","thumbnailUrl","thumbnailAltText","status","actions","withDragHandle","isDragActive","isLoading","onClick","href","cardDragHandleProps","cardDragHandleComponent","isActionsDisabled"]);let s=$(),q=()=>{if(T)return T;if(z)return e.createElement(DragHandle,l({className:s.dragHandle,isActive:P,label:"Reorder entry"},_))},u="article",v=!1;(g||H)&&(u=g?"a":"button",v=!0);let J=f==="archived"||!I;return e.createElement("li",d(l({},G),{className:cx(s.root({isDragActive:P}),t),"data-test-id":n}),q(),U?e.createElement("article",{className:s.card(!1)},e.createElement(Skeleton.Container,{svgHeight:46,clipId:"f36-entity-list-item-skeleton"},e.createElement(Skeleton.Image,{height:46,width:46}),e.createElement(Skeleton.BodyText,{numberOfLines:2,lineHeight:18,offsetLeft:54}))):e.createElement(e.Fragment,null,e.createElement(u,l(l({className:s.card(v),onClick:H,href:g},g?{target:"_blank"}:{}),u==="button"?{type:"button"}:{}),W&&e.createElement("figure",{className:s.media},J?e.createElement(Icon,{as:pt[m.toLowerCase()],variant:"muted","data-test-id":`thumbnail-icon-${m.toLowerCase()}`}):e.createElement("img",{src:I,className:s.thumbnail,alt:O})),e.createElement("div",{className:s.content},e.createElement(Flex,null,e.createElement(Text,{as:"h3",lineHeight:"lineHeightM",fontColor:"gray900",fontWeight:"fontWeightDemiBold",isTruncated:!0},o),b&&e.createElement(Text,{as:"span",lineHeight:"lineHeightM",fontColor:"gray600",className:s.contentType,isTruncated:!0},"(",b,")")),e.createElement(Flex,{marginTop:"spacing2Xs"},m&&e.createElement(Text,{lineHeight:"lineHeightM",fontColor:"gray600",className:s.entityType},m),r&&e.createElement(Text,{as:"p",lineHeight:"lineHeightM",fontColor:"gray900",isTruncated:!0,className:s.description},r))),e.createElement(Flex,{className:s.meta,alignItems:"flex-start",paddingLeft:"spacingXs"},f&&e.createElement(Box,{marginRight:h?"spacingXs":"none"},e.createElement(EntityStatusBadge,{entityStatus:f})))),h&&e.createElement(Menu,null,e.createElement(Menu.Trigger,null,e.createElement(Button,{isDisabled:j,startIcon:e.createElement(MoreHorizontalIcon,null),variant:"transparent","aria-label":"Actions",size:"small",className:s.menuTrigger})),e.createElement(Menu.List,null,h))))};y.displayName="EntityListItem";var F=B;F.Item=y;

export { F as EntityList, y as EntityListItem };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.js.map